#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Edit ALL configuration values in the Temp_Conf_System tablein a single screen.

my %lex = ('Eoy' => 'Eoy',
	   'Configuration' => 'Configuration',
	   'Error' => 'Error',
	   'Edit' => 'Edit',
	   'View' => 'View',
	   'Section' => 'Section',
	   'Name' => 'Name',
	   'Value' => 'Value',
	   'Type' => 'Type',
	   'Update Record(s)' => 'Update Record(s)',
	   'Version' => 'Version',
	   'Description' => 'Description',
	   'Sequence' => 'Sequence',
	   'File' => 'File',
	   'Linked' => 'Linked',
	   'Record(s) Updated' => 'Record(s) Updated',
	   'No Change' => 'No Change',
	   'Eoy' => 'Eoy',
	   'Variable' => 'Variable',
	   'Admin' => 'Admin',
	   'Main' => 'Main',
	   'Start' => 'Start',
	   'Set' => 'Set',
	   'Save' => 'Save',
	   'Update' => 'Update',

	   );

my $self = 'confEditAllTemp.pl';

my @types = qw( scalar scalaronoff array hash hashofarray arrayofhash ); # data types


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

#$dbase = 'mos';
#$user = 'root';
#$password = 'sezme';


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Page Header
my $title = "$lex{Edit} $lex{Configuration} - TEMP Conf system";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
<style type=\"text/css\">td.ra { text-align:right;font-weight:bold;}</style>
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">$lex{Main}</a> |\n";
print "<a href=\"$eoypage\">$lex{Eoy}</a> |\n";
print "<a href=\"$self\">$lex{Start}</a> ]\n";

print "<h1 style=\"display:inline;\">$title</h1>\n";

#foreach my $key ( keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

if ( not $arr{page} ) {
    showValues();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    editValues();

} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeValues();

} elsif ( $arr{page} == 4 ) { # reset filename records (sectionname sequenceval)
    delete $arr{page};
    getField(); 

} elsif ( $arr{page} == 5 ) {
    delete $arr{page};
    setField(); # write reset to all records.

} elsif ( $arr{page} == 6 ) {
    delete $arr{page};
#    updateFiles(); # rewrite files from conf_system table;
}



#----------------
sub showStartPage {
#----------------

    # Select Main Filename Sections to Display
    my $sth = $dbh->prepare("select distinct filename from temp_conf_system order by filename"); 
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    print "<p></p><table cellpadding=\"10\" cellspacing=\"0\" border=\"1\" style=\"margin:2em;\">\n";
    while ( my $filename = $sth->fetchrow ) {

	my $fileview = ucfirst $filename. '.conf';

	print "<tr><td><form action=\"$self\"  method=\"post\">\n";
	print "<input type=\"hidden\" name=\"filename\" value=\"$filename\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
	print "<input type=\"submit\" value=\"$lex{Edit} $fileview\"></form></td></tr>\n";

    }

    # Update Files
    print "<tr><td><form action=\"$self\"  method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"4\">\n";
    print "<input type=\"submit\" value=\"$lex{Update} $lex{Files}\"></form></td></tr>\n";


    print "</table></div></center></body></html>\n";

}

#-----------
sub getField { # page 4
#-----------

    # foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("select * from temp_conf_system order by filename, sectionname, sequenceval, dataname"); 
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # Start Form
    print "<form action=\"$self\"  method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"5\">\n";

    print "<h3><input type=\"submit\" value=\"$lex{Save}\"></h3>\n";

    my $prevname = '';
    my $first = 1;

    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	my $id = $r{id};
	my $dataname = $r{dataname};
	my $sectionname = $r{sectionname};
	my $sequenceval = $r{sequenceval};

	if ( $prevname ne $sectionname or not $sectionname ) {
	    if ( not $first ) { print "</table>\n"; } else { $first = 0; }

	    print "<h3>$r{filename} - $sectionname</h3>\n";
	    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	    print "<tr><th>$lex{Name}</th><th>$lex{Section}</th><th>Sequence $lex{Value}</th></tr>\n";
	}
	$prevname = $sectionname;

	print qq{<tr><td>$dataname</td><td><input type="text" name="S:$id" size="20" value="$sectionname"></td>};
	print qq{<td><input type="text" name="V:$id" value="$sequenceval" size="4"></td></tr>\n};

    }

    print "</table>\n";
    print "<h3><input type=\"submit\" value=\"$lex{Save}\"></h3>\n";
    print "</form></body></html>\n";

    exit;

}  # end of getField




#-------------
sub showValues {
#-------------

    #foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


    # Section Form
    print "<form action=\"$self\"  method=\"post\" style=\"display:inline\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"4\">\n";
    print "<input type=\"hidden\" name=\"filename\" value=\"$arr{filename}\">\n";
    print "<input type=\"submit\" value=\"$lex{Set} $lex{Section}\"></form>\n";


    my $sth = $dbh->prepare("select * from temp_conf_system order by filename, sectionname, sequenceval, dataname"); 
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    # Print Table Heading.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

    my ($prevsection, $currsection);

    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	my $id = $r{id};
	my $dataname = $r{dataname};
	my $datatype = $r{datatype};
	my $datavalue = $r{datavalue};
	my $sectionname = $r{sectionname};

	$prevsection = $currsection;
	$currsection = $sectionname;

	if ( $currsection ne $prevsection ) {
	    print "<tr><th>$r{filename}</th><th>$lex{Name}</th><th>$lex{Section}</th><th>$lex{Type}</th><th>$lex{Value}</th></tr>\n";
	}

	$datavalue =~ s/\</&lt;/g;
	$datavalue =~ s/\>/&gt;/g;

	print "<tr><td><form action=\"$self\"  method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
	print "<input type=\"submit\" value=\"$lex{Edit}\"></form></td>\n";

	print "<td>$dataname</td><td>$sectionname</td><td>$datatype</td><td>$datavalue</td></tr>\n";
	
    }

    print "</table></body></html>\n";

    exit;

}  # end of showValues



#-------------
sub editValues { # edit record whose is id passed
#-------------

    #foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
    print "<p><input type=\"submit\" value=\"$lex{'Update Record(s)'} \"></p>\n";

    # Get the Record
    my $sth = $dbh->prepare("select * from temp_conf_system where id = ?");
    $sth->execute( $arr{id} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $ref = $sth->fetchrow_hashref;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my %rec = %$ref;


    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # File Name
    print "<tr><td class=\"ra\">$lex{File}</td><td>$rec{filename}</td></tr>\n";

    # Section Name
    print "<tr><td class=\"ra\">$lex{Section}</td>\n";
    print "<td><input type=\"text\" name=\"sectionname\" size=\"20\" value=\"$rec{sectionname}\"></td></tr>\n";

    # Sequence Value
    print "<tr><td class=\"ra\">$lex{Sequence}</td>\n<td>";
    print "<input type=\"text\" name=\"sequenceval\" size=\"5\" value=\"$rec{sequenceval}\"></td></tr>\n";

    # Data Name
    print "<tr><td class=\"ra\">$lex{Name}</td>\n<td>";
    print "<input type=\"text\" name=\"dataname\" size=\"20\" value=\"$rec{dataname}\"></td></tr>\n";

    # Data Value
    print "<tr><td class=\"ra\">$lex{Value}</td>\n<td>";
    print "<textarea name=\"datavalue\" rows=\"4\" cols=\"60\">$rec{datavalue}</textarea></td></tr>\n";


    # Datatype
    print "<tr><td class=\"ra\">$lex{Type}</td>\n<td>";
    print "<select name=\"datatype\"><option>$rec{datatype}</option>\n";
    foreach my $type ( @types ) {
	if ( $type ne $rec{datatype} ) { print "<option>$type</option>\n"; }
    }
    print "<option></option></select>\n";


    # Linked hashvar  (which supplies values)
    print "<tr><td class=\"ra\">$lex{Linked} $lex{Variable}</td>\n<td>";
    print "<input type=\"text\" name=\"hashvar\" value=\"$rec{hashvar}\" size=\"15\"></td></tr>\n";


    # Version
    print "<tr><td class=\"ra\">$lex{Version}</td>\n<td>";
    print "<input type=\"text\" name=\"version\" size=\"20\" value=\"$rec{version}\"></td></tr>\n";


    # Description
    print "<tr><td class=\"ra\">$lex{Description}</td>\n<td>";
    print "<textarea rows=\"4\" cols=\"80\" name=\"description\">$rec{description}</textarea></td></tr>\n";


    print "</table><p></p>\n";

    print "<input type=\"submit\" value=\"$lex{'Update Record(s)'} \">\n";
    print "</form></body></html>\n";

    exit;


} # end of editValues



#--------------
sub writeValues {
#--------------
    
    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id};
    delete $arr{id};

    # Get the original record
    my $sth = $dbh->prepare("select * from temp_conf_system where id = ?");
    $sth->execute( $id );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $ref = $sth->fetchrow_hashref;
    my %orig = %$ref;
    my $filename = $orig{filename};

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    my $count;

    foreach my $key ( sort keys %arr ) {

	# Check for update, skip if no change.
	if ( $arr{$key} eq $orig{$key} ) { next; }

	my $sth = $dbh->prepare("update temp_conf_system set $key = ? where id = ?");
	$sth->execute( $arr{$key}, $id );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	# print line for this record.
	$count++;
	print "<tr><td>$count. <b>$key</b>: $orig{$key}</td><td>=> $arr{$key}</td></tr>\n";

	
    } # Next Field;

    print "</table>\n";

    if ( not $DBI::errstr and $count ) {
	print "<h3>". $lex{'Record(s) Updated'}. ".</h3>\n";
	updateFiles( $filename );
	print qq{<div>File Updated</div>\n};

    } else {
	print "<h3>". $lex{'No Change'}. ".</h3>\n";
    }

    
    print "</body></html>\n";

    exit;

} # End of writeValues;


#-----------
sub setField {
#-----------
    
    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }


    # Start Table
    # print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Set SQL
    my $sth1 = $dbh->prepare("update temp_conf_system set sectionname = ? where id = ?");
    my $sth2 = $dbh->prepare("update temp_conf_system set sequenceval = ? where id = ?");


    foreach my $key ( sort keys %arr ) {

	my ($type, $id) = split(':', $key );

	if ( $type eq 'S' ) { # sectionname
#	    print "S ID:$id Value:$arr{$key}<br>\n";
	    $sth1->execute( $arr{$key}, $id );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	} elsif ( $type eq 'V' ) { # sequenceval
#	    print "V ID:$id Value:$arr{$key}<br>\n";
	    $sth2->execute( $arr{$key}, $id );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	}
	
    } # Next Field;

    print "</table>\n";

    if ( not $DBI::errstr  ) {
	print "<h3>$lex{'Record(s) Updated'}</h3>\n";
    } else {
	print "<h3>$lex{Error} $DBI::errstr</h3>\n";
    }

    print "<p>[ <a href=\"$eoypage\">$lex{Eoy}</a> ]</p>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"submit\" value=\"$lex{Edit}\"></form>\n";

    print "</body></html>\n";

    exit;

} # End of setField;



#--------------
sub updateFiles {
#--------------

    # Note: needs file path: $g_EtcPath to write files to.

    if (not -e $g_EtcPath ) {
	print "<h3>$lex{Path} $lex{'Not Found'}</h3>\n";
    }

    my $singlefile = shift;

    my @files;
    if ( $singlefile ) {
	push @files, $singlefile;

    } else { # do them all
	my $sth = $dbh->prepare("select distinct filename from temp_conf_system 
         where filename is not NULL and filename != ''  order by filename");
	$sth->execute;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $filename = $sth->fetchrow ) {
	    push @files, $filename;
	}
    }


    foreach my $updatefile ( @files ) {

	my $filename = "$g_EtcPath/$updatefile.conf";
	
	print "<div>$lex{Update}: $filename</div>\n";

	# special case for admin.conf
	if ( $updatefile eq 'admin' ) { # use the admin.conf.root file.
	    unless ( -e "$g_EtcPath/admin.conf.root" ) {
		print "<h3>$g_EtcPath". '/admin.conf.root'. " $lex{'Not Found'}</h3>\n";
	    }
	    system("cp -f $g_EtcPath/admin.conf.root $g_EtcPath/admin.conf");
	    # print "Result:", $? >> 8, "<br>\n";

	    open(FH,">>$filename") or
		die "Cannot open file $filename: $!\n"; # open for append
	} else {
	    open(FH,">$filename") or
		die "Cannot open file $filename: $!\n";
	}


	my $sth = $dbh->prepare("select id, datavalue from temp_conf_system 
         where filename = ? order by dataname");
	$sth->execute( $updatefile );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	while ( my ($id, $value) = $sth->fetchrow ) {
	    print FH $value, "\n";
	}

	print FH "\n1;\n";
	close FH;

	print "<h3>$lex{File} $lex{Updated}: $updatefile</h3>\n";
    }

    if ( $singlefile ) { 
	return; 
    } else { # did them all
	print "</body></html>\n";
	exit;
    }
}

