#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Eoy' => 'Eoy',
	   'Configuration' => 'Configuration',
	   'Error' => 'Error',
	   'View' => 'View',
	   'Section' => 'Section',
	   'Name' => 'Name',
	   'Value' => 'Value',
	   'Type' => 'Type',
	   'Description' => 'Description',
	   'Eoy' => 'Eoy',
	   'Description' => 'Description',

	   );

my $self = 'confview.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Page Header
print "$doctype\n<html><head><title>$lex{View} $lex{Configuration}</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
<style type=\"text/css\">td.ra { text-align:right;font-weight:bold;}</style>
$chartype\n</head><body>\n";
print "[ <a href=\"$eoypage\">". $lex{Eoy}. "</a> |\n";

print "<center><h1>$lex{View} $lex{Configuration}</h1>\n";

#foreach my $key ( keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showValues();
}

#----------------
sub showStartPage {
#----------------

    # Select Main Filename Sections to Display
    my $sth = $dbh->prepare("select distinct filename from conf_system order by filename"); 
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    print "<table cellpadding=\"8\" cellspacing=\"0\" border=\"1\">\n";
    while ( my $filename = $sth->fetchrow ) {

	print "<tr><td><form action=\"$self\"  method=\"post\">\n";
	print "<input type=\"hidden\" name=\"filename\" value=\"$filename\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
	print "<input type=\"submit\" value=\"". $lex{View}. " $filename\"></form></td></tr>\n";

    }

    print "</table></center></body></html>\n";

}



#-------------
sub showValues {
#-------------


    my $sth = $dbh->prepare("select id, sectionname, dataname, datatype, datavalue, description
      from conf_system where filename = ? order by dataname"); 
    $sth->execute( $arr{filename} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    # Print Table Heading.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>$lex{Section}</th><th>$lex{Name}</th><th>$lex{Description}</th><th>$lex{Type}</th><th>$lex{Value}</th></tr>\n";

    while ( my ( $id, $groupname, $dataname, $datatype, $datavalue, $description ) = $sth->fetchrow ) {

	print "<tr><td>$groupname</td><td>$dataname</td><td>$description</td><td>$datatype</td><td>$datavalue</td></tr>\n";
    }

    print "</table></center></body></html>\n";

    exit;

}  # end of showValues
